﻿using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ContactLibrary;
using DAL;
using DAL.Interfaces;
using DAL.Repositories;
using Ninject;

namespace ConsoleTestApp
{
    class Program
    {
        static void Main(string[] args)
        {
            var kernel = new StandardKernel();
            kernel.Bind<IDbContext>().To<DataBaseContext>();
            kernel.Bind<IPersonRepository>().To<PersonRepository>();
            kernel.Bind<IContactRepository>().To<ContactRepository>();
            kernel.Bind<IContactTypeRepository>().To<ContactTypeRepository>();

            using (var personRepo = kernel.Get<PersonRepository>())
            {
                var person = new Person
                {
                    FirstName = "Andres",
                    LastName = "Käver",
                    Contacts = new List<Contact>
                    {
                       new Contact()
                {
                    ContactValue = "+372 6543210",
                    ContactType = new ContactType() { ContactTypeValue = "phone" }
                }, new Contact()
                {
                    ContactValue = "akaver",
                    ContactType = new ContactType() { ContactTypeValue = "skype" }

                }
                    }
                };

                foreach (var singleContact in person.Contacts.ToList())
                {
                    Console.WriteLine(
                        "Tüüp: " + singleContact.ContactType.ContactTypeValue +
                        " Väärtus:" + singleContact.ContactValue);
                }

                personRepo.Add(person);
                personRepo.Save();
            }

            using (var personRepo = kernel.Get<PersonRepository>())
            {
                foreach (var singlePerson in personRepo.All)
                {
                    Console.WriteLine(
                        "Nimi: " +
                        singlePerson.FirstName + " " +
                        singlePerson.LastName);
                    Console.WriteLine("Kontaktid:");
                    if (singlePerson.Contacts == null) continue;
                    foreach (var singleContact in singlePerson.Contacts)
                    {
                        Console.WriteLine("Väärtus:" + singleContact.ContactValue);
                        if (singleContact.ContactType == null) continue;
                        Console.WriteLine("Tüüp:"+singleContact.ContactType.ContactTypeValue);
                    }
                }
            }
            Console.WriteLine("================ DONE ==============");

        }
    }
}
